; Shepard tones - some additional variation

<CsoundSynthesizer>

<CsOptions>
-odac -dm0
</CsOptions>

<CsInstruments>

0dbfs     =       1

giSine   ftgen    0,0,4097,10,1
giOctFn  ftgen    0,0,1024,16,0,512,-4,1,512,4,0

alwayson        1
alwayson        2

instr    1
 kTone   phasor   rspline:k(-4,4,0.05,0.2)     ; random speed and direction phasor
 kDiv    =        int(rspline:k(7,17,0.2,0.1)) ; random divisor (integer between 7 and 17)
 gkTone  =      int(kTone*kDiv)/kDiv
 if changed(gkTone)==1 then                    ; generate a new note when gkTone changes
  event "i",2,0,3600,gkTone
 endif
 gkBrite rspline  0,4,0.1,0.2                  ; randomly shift spectrum zero to +4 octaves 
endin

instr    2
 if active:k(p1,0,1)>1 then                    ; turn off old note if a newer note exists
  turnoff
 endif
 aAmp    linsegr  0,0.01,1,0.01,0
 iOctCnt =        10
 iBasFrq =        110
 kBrite  =        0
 iTone   =        p4
 a1      hsboscil 0.6, iTone, gkBrite, iBasFrq, giSine, giOctFn, iOctCnt
         out      a1*aAmp
endin

</CsInstruments>

</CsoundSynthesizer>
